/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.javafxdata.datasources.provider;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.*;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.beans.value.ObservableValue;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableColumn.CellDataFeatures;
import javafx.util.Callback;
import org.javafxdata.control.cell.MapValueFactory;

/**
 *
 * @author johan
 */
public class JdbcDataSource extends DataSource<Map> {

    private String dbURL;
    private static Connection conn;
    private List<String> selectedColumnNames = new LinkedList<String>();

    public JdbcDataSource(String url, String table, String... cols) {
        this.dbURL = url;
        selectedColumnNames.addAll(Arrays.asList(cols));
        createConnection();
        int totcols = selectedColumnNames.size();
        if (totcols > 0) {

            try {
                String queryString = "SELECT ";
                int i = 0;
                while (i < totcols) {
                    queryString = queryString + selectedColumnNames.get(i);
                    i++;
                    if (i < totcols) {
                        queryString = queryString + ", ";
                    }
                }
                queryString = queryString + " FROM " + table;
                ResultSet resultSet = conn.createStatement().executeQuery(queryString);
                while (resultSet.next()) {
                    Map<String, String> map = new HashMap<String, String>();
                    add(map);
                    for (String c : selectedColumnNames) {
                        map.put(c, resultSet.getString(c));
                    }
                }
            } catch (SQLException ex) {
                Logger.getLogger(JdbcDataSource.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    private void createConnection() {
        try {
            Class.forName("org.apache.derby.jdbc.EmbeddedDriver").newInstance();
            conn = DriverManager.getConnection(dbURL);
        } catch (Exception except) {
            except.printStackTrace();
        }
    }


    @Override
    protected void buildColumns() {
        for (final String columnName : selectedColumnNames) {
            TableColumn<Map, Object> tc = new TableColumn<Map, Object>(columnName);
            Callback<CellDataFeatures<Map, Object>, ObservableValue<Object>> cb = new MapValueFactory<Object>(columnName);
            tc.setCellValueFactory(cb);
            addColumn(columnName, tc);
        }
    }

    @Override
    public TableColumn getNamedColumn(String firstName) {
        TableColumn answer = super.getNamedColumn(firstName);
        return answer;
    }
}
