package org.javafxdata.datasources.reader;

import java.io.*;
import java.util.List;
import org.javafxdata.datasources.Format;

/**
 *
 * @author johan
 */
public class JavaObjectSource<T> implements DataSourceReader {
    private final List<T> content;

    public JavaObjectSource (List<T> objects) {
        this.content = objects;
    }
    
    @Override
    public InputStream getInputStream() throws IOException {
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        ObjectOutputStream oos = new ObjectOutputStream(baos);
        for (T candidate: content) {
            oos.writeObject(candidate);
        }
        oos.flush();
        byte[] bytes = baos.toByteArray();
        return new ByteArrayInputStream(bytes);
        // we don't return an ObjectInputStream, since objects may also be
        // read from filesource or networksource, returning an InputStream
   //     ObjectInputStream ois = new ObjectInputStream (new ByteArrayInputStream(bytes));
     //   return ois;
    }

    @Override
    public Format getInputFormat() {
        return Format.JAVA_OBJECT;
    }
    
}
